

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.device_pyusb &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../../index.html" />
    <link rel="up" title="Module code" href="../index.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" accesskey="U">Module code</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <h1>Source code for pywws.device_pyusb</h1><div class="highlight"><pre>
<span class="sd">&quot;&quot;&quot;Low level USB interface to weather station, using PyUSB.</span>

<span class="sd">Introduction</span>
<span class="sd">============</span>

<span class="sd">This module handles low level communication with the weather station</span>
<span class="sd">via the `PyUSB &lt;http://sourceforge.net/apps/trac/pyusb/&gt;`_ library. An</span>
<span class="sd">alternative module, :doc:`pywws.device_cython_hidapi`, uses the</span>
<span class="sd">`cython-hidapi &lt;https://github.com/gbishop/cython-hidapi&gt;`_ library.</span>
<span class="sd">The choice of which module to use depends on which libraries are</span>
<span class="sd">available for you computer.</span>

<span class="sd">Users of recent versions of Mac OS have no choice. The operating</span>
<span class="sd">system makes it very difficult to access HID devices (such as the</span>
<span class="sd">weather station) directly, so the ``hidapi`` library has to be used.</span>
<span class="sd">``cython-hidapi`` is a Python interface to that library.</span>

<span class="sd">Users of OpenWRT and similar embedded Linux platforms will probably</span>
<span class="sd">not be able to install ``cython-hidapi``, so are constrained to use</span>
<span class="sd">``libusb`` and its ``PyUSB`` Python interface.</span>

<span class="sd">Installation</span>
<span class="sd">============</span>

<span class="sd">Some of this software may already be installed on your machine, so do</span>
<span class="sd">check before downloading sources and compiling them yourself.</span>

<span class="sd">#.  Install libusb and PyUSB.</span>

<span class="sd">    These should be available as packages for your operating system,</span>
<span class="sd">    but their names may vary. For example, on Ubuntu Linux::</span>

<span class="sd">        sudo apt-get install libusb-0.1 python-usb</span>

<span class="sd">    On some embedded linux systems::</span>

<span class="sd">        ipkg install libusb py25-usb</span>

<span class="sd">Testing</span>
<span class="sd">=======</span>

<span class="sd">Run ``TestWeatherStation.py`` with increased verbosity so it reports</span>
<span class="sd">which USB device access module is being used::</span>

<span class="sd">    python TestWeatherStation.py -vv</span>
<span class="sd">    18:28:09:pywws.WeatherStation.CUSBDrive:using pywws.device_pyusb</span>
<span class="sd">    0000 55 aa ff ff ff ff ff ff ff ff ff ff ff ff ff ff 05 20 01 41 11 00 00 00 81 00 00 0f 05 00 e0 51</span>
<span class="sd">    0020 03 27 ce 27 00 00 00 00 00 00 00 12 02 14 18 27 41 23 c8 00 00 00 46 2d 2c 01 64 80 c8 00 00 00</span>
<span class="sd">    0040 64 00 64 80 a0 28 80 25 a0 28 80 25 03 36 00 05 6b 00 00 0a 00 f4 01 12 00 00 00 00 00 00 00 00</span>
<span class="sd">    0060 00 00 49 0a 63 12 05 01 7f 00 36 01 60 80 36 01 60 80 bc 00 7b 80 95 28 12 26 6c 28 25 26 c8 01</span>
<span class="sd">    0080 1d 02 d8 00 de 00 ff 00 ff 00 ff 00 00 11 10 06 01 29 12 02 01 19 32 11 09 09 05 18 12 01 22 13</span>
<span class="sd">    00a0 14 11 11 04 15 04 11 12 17 05 12 11 09 02 15 26 12 02 11 07 05 11 09 02 15 26 12 02 11 07 05 11</span>
<span class="sd">    00c0 09 10 09 12 12 02 02 12 38 12 02 07 19 00 11 12 16 03 27 12 02 03 11 00 11 12 16 03 27 11 12 26</span>
<span class="sd">    00e0 21 32 11 12 26 21 32 12 02 06 19 57 12 02 06 19 57 12 02 06 19 57 12 02 06 19 57 12 02 06 19 57</span>

<span class="sd">API</span>
<span class="sd">===</span>

<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__docformat__</span> <span class="o">=</span> <span class="s">&quot;restructuredtext en&quot;</span>

<span class="kn">import</span> <span class="nn">platform</span>
<span class="kn">import</span> <span class="nn">usb</span>

<div class="viewcode-block" id="USBDevice"><a class="viewcode-back" href="../../api/pywws.device_pyusb.html#pywws.device_pyusb.USBDevice">[docs]</a><span class="k">class</span> <span class="nc">USBDevice</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">idVendor</span><span class="p">,</span> <span class="n">idProduct</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Low level USB device access via PyUSB library.</span>

<span class="sd">        :param idVendor: the USB ``vendor ID` number, for example 0x1941.</span>

<span class="sd">        :type idVendor: int</span>

<span class="sd">        :param idProduct: the USB ``product ID` number, for example 0x8021.</span>

<span class="sd">        :type idProduct: int</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">dev</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_find_device</span><span class="p">(</span><span class="n">idVendor</span><span class="p">,</span> <span class="n">idProduct</span><span class="p">)</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">dev</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">IOError</span><span class="p">(</span><span class="s">&quot;Weather station device not found&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">devh</span> <span class="o">=</span> <span class="n">dev</span><span class="o">.</span><span class="n">open</span><span class="p">()</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">devh</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">IOError</span><span class="p">(</span><span class="s">&quot;Open device failed&quot;</span><span class="p">)</span>
<span class="c">##        if platform.system() is &#39;Windows&#39;:</span>
<span class="c">##            self.devh.setConfiguration(1)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">devh</span><span class="o">.</span><span class="n">claimInterface</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
        <span class="k">except</span> <span class="n">usb</span><span class="o">.</span><span class="n">USBError</span><span class="p">:</span>
            <span class="c"># claim interface failed, try detaching kernel driver first</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">devh</span><span class="p">,</span> <span class="s">&#39;detachKernelDriver&#39;</span><span class="p">):</span>
                <span class="k">raise</span> <span class="ne">RuntimeError</span><span class="p">(</span>
                    <span class="s">&quot;Please upgrade pyusb (or python-usb) to 0.4 or higher&quot;</span><span class="p">)</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">devh</span><span class="o">.</span><span class="n">detachKernelDriver</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">devh</span><span class="o">.</span><span class="n">claimInterface</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
            <span class="k">except</span> <span class="n">usb</span><span class="o">.</span><span class="n">USBError</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">IOError</span><span class="p">(</span><span class="s">&quot;Claim interface failed&quot;</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">__del__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">devh</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">devh</span><span class="o">.</span><span class="n">releaseInterface</span><span class="p">()</span>
            <span class="k">except</span> <span class="n">usb</span><span class="o">.</span><span class="n">USBError</span><span class="p">:</span>
                <span class="c"># interface was not claimed. No problem</span>
                <span class="k">pass</span>

    <span class="k">def</span> <span class="nf">_find_device</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">idVendor</span><span class="p">,</span> <span class="n">idProduct</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Find a USB device by product and vendor id.&quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">bus</span> <span class="ow">in</span> <span class="n">usb</span><span class="o">.</span><span class="n">busses</span><span class="p">():</span>
            <span class="k">for</span> <span class="n">device</span> <span class="ow">in</span> <span class="n">bus</span><span class="o">.</span><span class="n">devices</span><span class="p">:</span>
                <span class="k">if</span> <span class="p">(</span><span class="n">device</span><span class="o">.</span><span class="n">idVendor</span> <span class="o">==</span> <span class="n">idVendor</span> <span class="ow">and</span>
                    <span class="n">device</span><span class="o">.</span><span class="n">idProduct</span> <span class="o">==</span> <span class="n">idProduct</span><span class="p">):</span>
                    <span class="k">return</span> <span class="n">device</span>
        <span class="k">return</span> <span class="bp">None</span>

<div class="viewcode-block" id="USBDevice.read_data"><a class="viewcode-back" href="../../api/pywws.device_pyusb.html#pywws.device_pyusb.USBDevice.read_data">[docs]</a>    <span class="k">def</span> <span class="nf">read_data</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">size</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Receive data from the device.</span>

<span class="sd">        If the read fails for any reason, an :obj:`IOError` exception</span>
<span class="sd">        is raised.</span>

<span class="sd">        :param size: the number of bytes to read.</span>

<span class="sd">        :type size: int</span>

<span class="sd">        :return: the data received.</span>

<span class="sd">        :rtype: list(int)</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">result</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">devh</span><span class="o">.</span><span class="n">interruptRead</span><span class="p">(</span><span class="mh">0x81</span><span class="p">,</span> <span class="n">size</span><span class="p">,</span> <span class="mi">1200</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">result</span> <span class="ow">is</span> <span class="bp">None</span> <span class="ow">or</span> <span class="nb">len</span><span class="p">(</span><span class="n">result</span><span class="p">)</span> <span class="o">&lt;</span> <span class="n">size</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">IOError</span><span class="p">(</span><span class="s">&#39;pywws.device_libusb.USBDevice.read_data failed&#39;</span><span class="p">)</span>
        <span class="k">return</span> <span class="nb">list</span><span class="p">(</span><span class="n">result</span><span class="p">)</span>
</div>
<div class="viewcode-block" id="USBDevice.write_data"><a class="viewcode-back" href="../../api/pywws.device_pyusb.html#pywws.device_pyusb.USBDevice.write_data">[docs]</a>    <span class="k">def</span> <span class="nf">write_data</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">buf</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Send data to the device.</span>

<span class="sd">        If the write fails for any reason, an :obj:`IOError` exception</span>
<span class="sd">        is raised.</span>

<span class="sd">        :param buf: the data to send.</span>

<span class="sd">        :type buf: list(int)</span>

<span class="sd">        :return: success status.</span>

<span class="sd">        :rtype: bool</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">result</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">devh</span><span class="o">.</span><span class="n">controlMsg</span><span class="p">(</span>
            <span class="n">usb</span><span class="o">.</span><span class="n">ENDPOINT_OUT</span> <span class="o">+</span> <span class="n">usb</span><span class="o">.</span><span class="n">TYPE_CLASS</span> <span class="o">+</span> <span class="n">usb</span><span class="o">.</span><span class="n">RECIP_INTERFACE</span><span class="p">,</span>
            <span class="n">usb</span><span class="o">.</span><span class="n">REQ_SET_CONFIGURATION</span><span class="p">,</span> <span class="n">buf</span><span class="p">,</span> <span class="n">value</span><span class="o">=</span><span class="mh">0x200</span><span class="p">,</span> <span class="n">timeout</span><span class="o">=</span><span class="mi">50</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">result</span> <span class="o">!=</span> <span class="nb">len</span><span class="p">(</span><span class="n">buf</span><span class="p">):</span>
            <span class="k">raise</span> <span class="ne">IOError</span><span class="p">(</span><span class="s">&#39;pywws.device_libusb.USBDevice.write_data failed&#39;</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">True</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="../index.html" >Module code</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>